OpenShot Audio Library | OpenShotAudio: juce::LagrangeInterpolator Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.1

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::LagrangeInterpolator Class Reference

`#include <juce_LagrangeInterpolator.h>`

## Public Member Functions
| LagrangeInterpolator (LagrangeInterpolator &&) noexcept=default
LagrangeInterpolator & | operator= (LagrangeInterpolator &&) noexcept=default
void | reset () noexcept
int | process (double speedRatio, const float *inputSamples, float *outputSamples, int numOutputSamplesToProduce) noexcept
int | process (double speedRatio, const float *inputSamples, float *outputSamples, int numOutputSamplesToProduce, int available, int wrapAround) noexcept
int | processAdding (double speedRatio, const float *inputSamples, float *outputSamples, int numOutputSamplesToProduce, float gain) noexcept
int | processAdding (double speedRatio, const float *inputSamples, float *outputSamples, int numOutputSamplesToProduce, int available, int wrapAround, float gain) noexcept

## Detailed Description

Interpolator for resampling a stream of floats using 4-point lagrange interpolation.

Note that the resampler is stateful, so when there's a break in the continuity of the input stream you're feeding it, you should call reset() before feeding it any new data. And like with any other stateful filter, if you're resampling multiple channels, make sure each one uses its own LagrangeInterpolator object.

See also
  CatmullRomInterpolator

Definition at line 39 of file juce_LagrangeInterpolator.h.

## Constructor & Destructor Documentation

## ◆ LagrangeInterpolator()

juce::LagrangeInterpolator::LagrangeInterpolator | ( |  | ) |
| noexcept

Definition at line 436 of file juce_LagrangeInterpolator.cpp.

## ◆ ~LagrangeInterpolator()

juce::LagrangeInterpolator::~LagrangeInterpolator | ( |  | ) |
| noexcept

Definition at line 437 of file juce_LagrangeInterpolator.cpp.

## Member Function Documentation

## ◆ process() [1/2]

int juce::LagrangeInterpolator::process | ( | double | speedRatio,
|  | const float * | inputSamples,
|  | float * | outputSamples,
|  | int | numOutputSamplesToProduce
| ) |  |
| noexcept

Resamples a stream of samples.

Parameters

  speedRatio | the number of input samples to use for each output sample
  inputSamples | the source data to read from. This must contain at least (speedRatio * numOutputSamplesToProduce) samples.
  outputSamples | the buffer to write the results into
  numOutputSamplesToProduce | the number of output samples that should be created

Returns
  the actual number of input samples that were used

Definition at line 452 of file juce_LagrangeInterpolator.cpp.

## ◆ process() [2/2]

int juce::LagrangeInterpolator::process | ( | double | speedRatio,
|  | const float * | inputSamples,
|  | float * | outputSamples,
|  | int | numOutputSamplesToProduce,
|  | int | available,
|  | int | wrapAround
| ) |  |
| noexcept

Resamples a stream of samples.

Parameters

  speedRatio | the number of input samples to use for each output sample
  inputSamples | the source data to read from. This must contain at least (speedRatio * numOutputSamplesToProduce) samples.
  outputSamples | the buffer to write the results into
  numOutputSamplesToProduce | the number of output samples that should be created
  available | the number of available input samples. If it needs more samples than available, it either wraps back for wrapAround samples, or it feeds zeroes
  wrapAround | if the stream exceeds available samples, it wraps back for wrapAround samples. If wrapAround is set to 0, it will feed zeroes.

Returns
  the actual number of input samples that were used

Definition at line 447 of file juce_LagrangeInterpolator.cpp.

## ◆ processAdding() [1/2]

int juce::LagrangeInterpolator::processAdding | ( | double | speedRatio,
|  | const float * | inputSamples,
|  | float * | outputSamples,
|  | int | numOutputSamplesToProduce,
|  | float | gain
| ) |  |
| noexcept

Resamples a stream of samples, adding the results to the output data with a gain.

Parameters

  speedRatio | the number of input samples to use for each output sample
  inputSamples | the source data to read from. This must contain at least (speedRatio * numOutputSamplesToProduce) samples.
  outputSamples | the buffer to write the results to - the result values will be added to any pre-existing data in this buffer after being multiplied by the gain factor
  numOutputSamplesToProduce | the number of output samples that should be created
  gain | a gain factor to multiply the resulting samples by before adding them to the destination buffer

Returns
  the actual number of input samples that were used

Definition at line 462 of file juce_LagrangeInterpolator.cpp.

## ◆ processAdding() [2/2]

int juce::LagrangeInterpolator::processAdding | ( | double | speedRatio,
|  | const float * | inputSamples,
|  | float * | outputSamples,
|  | int | numOutputSamplesToProduce,
|  | int | available,
|  | int | wrapAround,
|  | float | gain
| ) |  |
| noexcept

Resamples a stream of samples, adding the results to the output data with a gain.

Parameters

  speedRatio | the number of input samples to use for each output sample
  inputSamples | the source data to read from. This must contain at least (speedRatio * numOutputSamplesToProduce) samples.
  outputSamples | the buffer to write the results to - the result values will be added to any pre-existing data in this buffer after being multiplied by the gain factor
  numOutputSamplesToProduce | the number of output samples that should be created
  available | the number of available input samples. If it needs more samples than available, it either wraps back for wrapAround samples, or it feeds zeroes
  wrapAround | if the stream exceeds available samples, it wraps back for wrapAround samples. If wrapAround is set to 0, it will feed zeroes.
  gain | a gain factor to multiply the resulting samples by before adding them to the destination buffer

Returns
  the actual number of input samples that were used

Definition at line 457 of file juce_LagrangeInterpolator.cpp.

## ◆ reset()

void juce::LagrangeInterpolator::reset | ( |  | ) |
| noexcept

Resets the state of the interpolator. Call this when there's a break in the continuity of the input data stream.

Definition at line 439 of file juce_LagrangeInterpolator.cpp.

The documentation for this class was generated from the following files:

- juce_LagrangeInterpolator.h
- juce_LagrangeInterpolator.cpp